## guardian 1.5.3

=== Makefile ===
# -*- makefile -*-

PACKAGE = guardian

SVERS := $(shell git describe | sed -e 's/_/~/' -e 's/-/+/' -e 's/-/~/' -e 's|.*/||')
VFILE := lib/guardian/_version.py
CVERS := $(shell test -e $(VFILE) && PYTHONPATH=lib python3 -m guardian.version)
DIST := $(PACKAGE)-$(SVERS)

WITH_SYSTEMD := $(shell which systemd-run)
ifdef WITH_SYSTEMD
  TEST_NAME := guardtest_$(shell date | md5sum | cut -b -7)
  TEST_EXEC := systemd-run --user --scope --unit=$(TEST_NAME) --slice=$(TEST_NAME) #--collect
  TEST_CLEAN := systemctl --user stop $(TEST_NAME).slice
endif

##########

.PHONY: all
all: build

.PHONY: test
test:
	$(TEST_EXEC) ./test/guardian-test $(GUARD_TEST_OPTS)
	$(TEST_CLEAN)
test-verbose:
	$(TEST_EXEC) ./test/guardian-test --verbose $(GUARD_TEST_OPTS)
	$(TEST_CLEAN)

##########

.PHONY: docs
docs:
	$(MAKE) -C docs html
	$(MAKE) -C docs latexpdf

##########

.PHONY: version _release-commit release-major release-minor release-rev release
version:
	echo "__version__ = '$(VERSION)'" >$(VFILE)
_release-commit: test version
	git add $(VFILE)
	git commit -m "Release $(VERSION)"
	git tag -m "Release" $(VERSION)
release-major: VERSION = $(shell PYTHONPATH=lib python3 -m guardian.version -r major $(SVERS))
release-major: _release-commit
release-minor: VERSION = $(shell PYTHONPATH=lib python3 -m guardian.version -r minor $(SVERS))
release-minor: _release-commit
release-rev: VERSION = $(shell PYTHONPATH=lib python3 -m guardian.version -r rev $(SVERS))
release-rev: _release-commit

##########

.PHONY: dist
dist: version
	python3 ./setup.py sdist

.PHONY: build
build: version
	python3 ./setup.py build

.PHONY: install
ifndef PREFIX
install: version
	python3 ./setup.py install
else
install: version
	python3 ./setup.py install --prefix=$(PREFIX)
endif

##################################################

# Debian/Ubuntu test package
.PHONY: deb-snapshot
# FIXME: do this without creating a dist tarball
deb-snapshot: dist
	mkdir -p build
	cd build; tar zxf ../dist/$(DIST).tar.gz
	cp -a debian build/$(DIST)
	cd build/$(DIST); dch -b -v $(SVERS) -D UNRELEASED 'test build, not for upload'
	cd build/$(DIST); echo '3.0 (native)' > debian/source/format
	cd build/$(DIST); debuild -us -uc

.PHONY: deb dsc
deb-src: VERSION = $(shell git describe master)
deb-src: DIST = $(PACKAGE)-$(CVERS)
deb-src:
	rm -rf build/$(VERSION)
	rm -rf build/$(DIST)
	mkdir -p build/$(VERSION)
	git archive master | tar -x -C build/$(VERSION)/
	cd build/$(VERSION) && python3 setup.py sdist
	mv build/$(VERSION)/dist/$(DIST).tar.gz build/$(PACKAGE)_$(VERSION).orig.tar.gz
	cd build && tar xf $(PACKAGE)_$(VERSION).orig.tar.gz
	mkdir build/$(DIST)/debian
	git archive debian:debian | tar -x -C build/$(DIST)/debian/
dsc: VERSION = $(shell git describe master)
dsc: DIST = $(PACKAGE)-$(VERSION)
dsc: deb-src
	cd build/$(DIST) && dpkg-source -b .
deb: VERSION = $(shell git describe master)
deb: DIST = $(PACKAGE)-$(VERSION)
deb: deb-src
	cd build/$(DIST) && debuild -uc -us

##########

.PHONY: clean
clean:
	rm -rf dist
	rm -rf build
	rm -rf test/tmp.*

=== devel/Makefile ===
# -*- makefile -*-

.PHONY: all
all: colors.adl

colors.adl: gen-color-adl.sh
	./gen-color-adl.sh > colors.adl

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error "The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/")
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/AdvancedLIGOGuardian.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/AdvancedLIGOGuardian.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/AdvancedLIGOGuardian"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/AdvancedLIGOGuardian"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== docs/_static/Makefile ===
# IMGS = $(overview-full.png)

# all: $(IMGS)

overview-full.png: overview.svg
	inkscape \
	--export-png=$@ \
	--export-id='layer7' \
	$<
	#--export-area=0:0:1000:1000 \

graph.png: graph.svg
	inkscape \
	--export-png=$@ \
	$<

## guardian 1.5.2

=== debian/changelog ===
guardian (1.5.2-1) stable; urgency=medium

  * new guardutil command to print all channel values from EPICS
  * Removed default 100 lines limit when asking for guardian logs
  * Add button to open guardian code archive gitk.
  * fix code history button label
  * Expanded the state screen to have more controls and manager information
  * medm: remove unused "related display" menu button generator

 -- Erik von Reis <evonreis@caltech.edu>  Sat, 02 Mar 2024 13:59:58 -0800

guardian (1.5.0-1) unstable; urgency=medium

  * New minor release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 20 Dec 2022 14:31:41 -0800

guardian (1.4.4-1) unstable; urgency=medium

  * bug fix release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Mon, 11 Jan 2021 13:32:44 -0800

guardian (1.4.3-1) unstable; urgency=medium

  * bug fix release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Thu, 23 Jul 2020 14:29:09 -0700

guardian (1.4.2-1) unstable; urgency=medium

  * bug fix release
  * specify minimum versions for dependencies
  * add symlink for MEDM screens in /usr/share

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 21 Jul 2020 10:56:38 -0700

guardian (1.4.1-1) unstable; urgency=medium

  * New rev release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Thu, 07 May 2020 11:36:20 -0700

guardian (1.4.0-1) unstable; urgency=medium

  * New release (python3 only)

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Wed, 29 Apr 2020 13:03:14 -0700

guardian (1.3.4-1) unstable; urgency=medium

  * New rev release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 26 Feb 2019 23:32:49 -0800

guardian (1.3.3-1) unstable; urgency=medium

  * New rev release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Fri, 08 Feb 2019 17:17:20 -0800

guardian (1.3.2-1) unstable; urgency=medium

  * New rev release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Thu, 07 Feb 2019 09:06:21 -0800

guardian (1.3.1-1) unstable; urgency=medium

  * New rev release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 05 Feb 2019 13:38:29 -0800

guardian (1.3.0-1) unstable; urgency=medium

  * New minor release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Mon, 04 Feb 2019 12:06:08 -0800

guardian (1.2.2-1) unstable; urgency=medium

  * New minor release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Thu, 23 Aug 2018 09:51:02 -0700

guardian (1.2.1-1) unstable; urgency=medium

  * New minor release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Mon, 07 May 2018 21:49:05 -0700

guardian (1.2.0-1) unstable; urgency=medium

  * New release (single thread)

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Fri, 20 Apr 2018 07:55:16 -0700

guardian (1.1.3-1) unstable; urgency=medium

  * New minor (brown bag) release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 06 Mar 2018 14:20:46 -0800

guardian (1.1.2-1) unstable; urgency=medium

  * New minor release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 06 Mar 2018 13:11:01 -0800

guardian (1.1.1-1) unstable; urgency=medium

  * New minor release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Fri, 02 Mar 2018 12:16:10 -0800

guardian (1.1.0-1) unstable; urgency=medium

  * New release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Mon, 26 Feb 2018 16:07:09 -0800

guardian (1.0.6-1) unstable; urgency=medium

  * New release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Fri, 09 Feb 2018 19:01:50 -0800

guardian (1.0.5-2) unstable; urgency=medium

  * depend on python-ezca which was broken out of cdsutils

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 30 Jan 2018 18:04:43 -0800

guardian (1.0.5-1) unstable; urgency=medium

  * New release

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Fri, 19 Jan 2018 20:16:12 -0800

guardian (1.0.4-2) unstable; urgency=medium

  * enable tests during build

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Tue, 13 Jun 2017 17:19:42 -0700

guardian (1.0.4-1) unstable; urgency=medium

  * New release.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Wed, 12 Oct 2016 18:21:48 -0700

guardian (1.0.0-1) unstable; urgency=low

  * New packaging.

 -- Jameson Graef Rollins <jameson.rollins@ligo.org>  Thu, 02 Jun 2016 11:51:31 -0700

=== debian/control ===
Source: guardian
Section: science
Priority: optional
Maintainer: Jameson Graef Rollins <jameson.rollins@ligo.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-python,
 epics-catools,
 python3,
 python3-ezca (>= 1.4),
 python3-git (>= 2.0),
 python3-gpstime,
 python3-networkx (>= 2.2),
 python3-numpy,
 python3-pcaspy (>= 0.7.1),
 python3-setuptools,
 python3-termcolor,
Standards-Version: 4.5.0
Homepage: https://git.ligo.org/cds/guardian
Vcs-Git: https://git.ligo.org/cds/guardian.git
Rules-Requires-Root: no

Package: guardian
Provides:
 python3-guardian,
Architecture: any
Depends:
 python3-networkx (>= 2.2),
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 gitk,
 ipython3,
 medm,
 python3-cdsutils,
 python3-ezca (>= 1.4),
 python3-git (>= 2.0),
 python3-gpstime,
 python3-numpy,
 python3-pcaspy (>= 0.7.1),
 python3-pydot,
 python3-setproctitle,
 python3-systemd,
 python3-termcolor,
Suggests:
 cdsutils,
Description: Advanced LIGO Guardian state machine automation platform
 Guardian is a python-based automation platform.  Independent
 automatons are programmed with state graph modules that define the
 automation logic for an individual sub-system.  A hierarchy of
 automatons can be linked together to control a full system.
 .
 Guardian uses EPICS for communication.  Each automaton node presents
 an EPICS channel access server control interface, and uses an EPICS
 client to communicate with the systems it controls (such as front end
 IOCs controlling hardware devices, or other guardian nodes that it
 supervises).
 .
 This package includes the Guardian automation process itself
 (guardian), EPICS MEDM control screens (guardmedm), and utility tools
 for analysing system modules (guardutil).  The pcaspy and python-ezca
 packages are required for running the daemon.

Package: guardctrl
Architecture: any
Depends:
 python3-gpstime,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 daemontools,
 guardian,
 openssh-client,
 python3-termcolor,
 systemd,
 systemd-container,
Suggests:
 xterm,
Description: Advanced LIGO Guardian process control/log interface
 This package provides the infrastucture needed to run guardian nodes
 under systemd supervision.  The guardctrl command line tool provides
 a convenience wrapping of systemctl calls specifically targeted for a
 guardian site deployment.  The guardctrl CLI also includes an
 interface for reading logs from supervised guardian nodes via
 journalctl.

## guardian 1.5.3

=== debian/changelog ===
guardian (1.5.3-1) stable; urgency=medium

  * fix for Debian13 + Python3.13.5

 -- Erik von Reis <evonreis@caltech.edu>  Thu, 26 Feb 2026 16:24:26 -0800

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME = guardian

%:
	dh $@ --with python3 --buildsystem pybuild

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./test/guardian-test
endif

override_dh_installchangelogs:
	dh_installchangelogs NEWS.md
